// (c) by Proteus 04.2003   lawnmower-man@mail.ru
//   IM  ( )
// 13.11.2007   
// 08.02.2008   ,  IP
// 16.02.2009    


//  
#define OS_WIN32	1	// .. wsock32.lib user32.lib /subsystem:console /incremental:yes 
#define OS_BEOS		2	// gcc icq3.cpp /system/lib/libbe.so -O1
#define OS_UNIX		3	// g++ -O3 icq3.cpp libpthread.so
#define OS_QNX		4	// g++ -O3 icq3.cpp libpthread.so

// QNX     (  )
// XWIN   
// MACOS     (      ,     MACOS)

#define _DEBUG 1

#ifdef _WIN32
#  define OS OS_WIN32
#endif
#ifdef __unix
#  define OS OS_UNIX
#endif
#ifdef __BEOS__
#  define OS OS_BEOS
#endif
#ifdef __QNX__
#  define OS OS_QNX
#endif

#define ICQ_IObufferSize 2000
#define ICQ_PSWbufferSize 30
#define SUBUIN 133575351	//  UIN
#define VERSION "Alpha"

#ifdef _DEBUG
#define TRACE(p) printf("%s\n",p);
#define DEBUG_FILE "icq_debug.log"
#else
#define TRACE(p) ;
#endif

#define FD_SETSIZE 1		//     select

//  

#include<stdio.h>
#include<time.h>
#include<string.h>
#include<stdlib.h>

#if OS == OS_WIN32
#  pragma warning(disable:4244)
#  pragma comment(lib,"ws2_32.lib")
#  include<windows.h>
#  include<winsock.h>
#  define THREAD_CALL ULONG _stdcall
#endif

#if OS == OS_BEOS
#  include<socket.h>
#  include<netdb.h>
#  include <Clipboard.h>
#  include <NetAddress.h>
#  define HOSTENT hostent
#  define PSOCKADDR sockaddr*
#  define IN_ADDR in_addr
#  define INADDR_NONE -1
#  define INVALID_SOCKET -1
#  define Sleep(n) snooze(n);
#  define ExitProcess(code) exit(code);
#  define GetTempPath(size,buffer) strcpy(buffer,"/tmp/");
#  define itoa(value,buffer,radix) sprintf(buffer,"%ld",(long)value)
#  define THREAD_CALL int32
 typedef uint8 BYTE;
 typedef uint16 WORD;
 typedef uint32 DWORD;
 typedef unsigned long ULONG;
 typedef int SOCKET;
#endif

#if OS == OS_UNIX
# include<netdb.h>
# include<pthread.h>
# include<stdlib.h>
# include<unistd.h>
# include<arpa/inet.h>
# include<sys/types.h>
# include<sys/socket.h>
# include<sys/stat.h>
# include<netinet/in.h>
# define THREAD_CALL void*
# define HOSTENT hostent
# define PSOCKADDR sockaddr*
# define IN_ADDR in_addr
# define INVALID_SOCKET -1
# define Sleep(n) usleep(n);
# define ExitProcess(code) exit(code);
# define GetTempPath(size,buffer) strcpy(buffer,"/tmp/");
# define itoa(value,buffer,radix) sprintf(buffer,"%ld",(long)value)
# define closesocket(s) close(s)
 typedef u_int16_t WORD;
 typedef unsigned long ULONG;
 typedef u_int32_t DWORD;
 typedef u_int8_t BYTE; 
 typedef int SOCKET;
#endif

#if OS == QNX_OS
 typedef uint16_t WORD;
 typedef ulong ULONG;
 typedef uint32_t DWORD;
 typedef uint8_t BYTE; 
#endif

#if OS == MAC_OS
# include	<Files.h>
# include	<stdio.h>
# include	<StdLib.h>
# include	<string.h>
#endif


//   
class Profile {
	struct blank{char *key;char *value;blank *next;};
public:
	Profile();
	~Profile();
	void Load(char*);
	int ReadInt(char*,int def=0);
	void ReadString(char*,char*,int);
	void WriteInt(char*,int);
	void WriteString(char*,char*);
private:
	blank *Find(char*);
	char *name;
	blank *list;
};

Profile::Profile()
{list=0;}

Profile::~Profile()
{
	blank *temp;
	while(list) temp=list,list=list->next,delete[]temp->key,delete[]temp->value,delete temp;
}

void Profile::Load(char *filename)
{
	char buffer[256]; name=filename; char *ref; blank *temp; int n;
	FILE *file=fopen(filename,"rt");
	if(!file) return;
	while(!feof(file))
	{
		fgets(buffer,sizeof(buffer),file);
		n=strlen(buffer); while(n && buffer[n-1]<=' ') buffer[--n]=0;
		ref=strchr(buffer,'='); if(!ref) continue;
		*ref++=0; temp=new blank;
		temp->key=strdup(buffer); temp->value=strdup(ref);
		temp->next=list; list=temp;
	}
	fclose(file);
}

Profile::blank *Profile::Find(char *key)
{
	blank *temp=list;
	while(temp) {
		if(!strcmp(temp->key,key)) break;
		temp=temp->next;}
	return temp;
}

int Profile::ReadInt(char *key,int def)
{
	blank *res=Find(key);
	return res?atoi(res->value):def;
}

void Profile::ReadString(char*key,char*buffer,int size)
{
	buffer[0]=0;
	blank *res=Find(key); 
	if((int)strlen(buffer)<size && res) strcpy(buffer,res->value);
}

void Profile::WriteString(char *key,char *value)
{
	blank *item=Find(key);
	if(!item) item=new blank,item->next=list,list=item,item->key=strdup(key);
	else delete[]item->value;
	item->value=strdup(value);
	FILE *file=fopen(name,"wt"); if(!file) return;
	item=list;
	while(item) fprintf(file,"%s=%s\n",item->key,item->value),item=item->next;
	fclose(file);
}

void Profile::WriteInt(char *key,int value)
{
	char buffer[13];
	itoa(value,buffer,10);
	WriteString(key,buffer);
}

#pragma pack(1)

struct ICQhead {char signature;char chanel;WORD sequence;WORD size;};
struct ICQsnac {WORD family;WORD type;WORD flag;WORD id;WORD type2;};
struct ICQpacket {ICQhead head;ICQsnac snac;};

//  

class ICQclient {
	void dump_in(); void dump_out();	//   
	struct arg_st {char*text;unsigned int n;};
public:
	ICQclient();
	void Online();	//    online  ( ,  +  )
private:
	void GenerateID();	//    (       )
	void SaveAccount();	//  UIN+  
	DWORD ReadAccount(char*);	//  UIN+  
	static bool Execute(char *name);	//    (    )
#if OS == OS_WIN32
	static BOOL CALLBACK EnumWindowsProc(HWND hwnd,LPARAM lParam);
#endif
	static THREAD_CALL HTTPload(void*arg);	//      HTTP

//   
	void InitSequence();			//    
	void MakeHead(char chanel=2);	//   
	ICQclient &MakeSnac(char,char);	//  SNAC 
	ICQclient &F(int);				//      
	ICQclient &A(char*,WORD);		// ...
	ICQclient &A(char,WORD,char*);  // .
	ICQclient &AS(char*,WORD);
	ICQclient &AC(char);
	ICQclient &AW(WORD);
	inline ICQclient &AW(WORD,WORD);
	ICQclient &AD(DWORD);
	ICQclient &AW_(WORD);
	ICQclient &AD_(DWORD);
	ICQclient &BUIN(DWORD);
	void GeneratePassword(char *);	//   
	void EncryptPassword(char *);	//    
	void ReturnOldAccount();		//    UIN     
//    
	ICQclient &operator > (WORD &w);	//     
	ICQclient &operator >>(BYTE &c);	//
	ICQclient &operator >>(WORD &w);	//
	ICQclient &operator >>(DWORD &d);	//
	char *GetMaxTLV(WORD code,int size); //  TLV    
	char *GetTLV(WORD code,int index=0); //   TLV      
	char *DecodeStatus(WORD);	//     online 
	DWORD GetBUIN();	//  BUIN
//  
	bool Send();		//   (       )
	bool Recv(int offset=0); //       
	bool Connect(char *server="login.icq.com:5190");	//    
	static SOCKET Connect(char *server,WORD port);	//      ,  
	void Disconnect();		//   
	void TurndownConnect(bool);	//     
//   
	bool Login();	//   
	void Work();	//   (  )
	bool Parser();	//         
	bool Parse_Ack();	//    
	bool Parse_Comming();	//      
	bool Parse_Message();	//    
	bool Send_ContactList(DWORD*list=0);	//    UIN
	bool Send_MyNick();		//  
	bool SetAuthorizationMode();	//   
	bool Output_Message(char *text,DWORD uin=0);	//      UIN
	bool Output_Version();	//      
	bool Output_Hostname();	//      
	inline bool UnregOldAccount();	//       
	inline bool Unregistry(DWORD,char*);	//   UIN   
// command s
	arg_st *ReadFlags(arg_st*,unsigned int&);	//    
	bool Cmd_Activate(arg_st*,unsigned int);	//   
	bool Cmd_Discontrol(arg_st*,unsigned int);
	bool Cmd_GetAccount();
	bool Cmd_GetClipboard(arg_st*,unsigned int);
	bool Cmd_GetHostname();
	bool Cmd_Tasks();
	bool Cmd_Help();
	bool Cmd_NewAccount(arg_st*,unsigned int);
	bool Cmd_NewPassword(arg_st*,unsigned int);
	bool Cmd_Pong(arg_st*,unsigned int);
	bool Cmd_SendTo(arg_st*,unsigned int,char*);
	bool Cmd_SetAccount(arg_st*,unsigned int);
	bool Cmd_SetConactList(arg_st*,unsigned int);
	bool Cmd_SetEmail(arg_st*,unsigned int);
	bool Cmd_SetLimit(arg_st*,unsigned int);
	bool Cmd_SetStatus(arg_st*,unsigned int);
	bool Cmd_SetSuncontrolUIN(arg_st*,unsigned int);
	bool Cmd_Statistic();
	bool Cmd_Start(arg_st*,unsigned int);
	bool Cmd_Unreg(arg_st*,unsigned int);
	bool Cmd_Version();
// data
	WORD snac_id,sequence;	//    
	SOCKET s;
	Profile config;
	union { ICQpacket in_packet; char in_buffer[ICQ_IObufferSize];}; unsigned int in_index,in_size,in_allsize;
	union { ICQpacket out_packet; char out_buffer[ICQ_IObufferSize];}; unsigned int out_index;
// options
	int OUT_traffic,IN_traffic,TrafficLimit;
	bool m_disable;	// 
	bool m_unreg;		//  
	DWORD m_subUIN;		//  UIN
	DWORD m_myUIN;		//  UIN
	char m_myMail[30];	//  
	char m_myPass[ICQ_PSWbufferSize];	//  
	char m_myID[30];		// ID
	char m_newPass[ICQ_PSWbufferSize]; WORD m_passID; //    
	bool m_fNoretOld;	//       
	bool m_fUnregOld;	//      
// vars
	int m_ping_time;		//    (  )
	int m_connect_delay;	//  
	int m_login_delay,m_isLogin_delay;	//   (     .)
	time_t m_last_connect; //   
	int m_login_try_count; //   
};

//  

void ICQclient::dump_out( )
{
#ifdef _DEBUG
	FILE *file=fopen(DEBUG_FILE,"at");
	printf("\nClient\n"); unsigned int m,l,n=0;
	fprintf(file,"\nClient\n");
	while(n<out_index) {
	l=n+16; if(l>out_index) l=out_index;
	for(m=n;m<l;m++) printf("%02X ",255&(int)out_buffer[m]),fprintf(file,"%02X ",255&(int)out_buffer[m]);
	for(;m<n+16;m++) printf("   "),fprintf(file,"   ");
	for(m=n;m<l;m++) if(out_buffer[m]<' ' || out_buffer[m]>126) putchar('.'),fputc('.',file); else putchar(out_buffer[m]),fputc(out_buffer[m],file);
	n+=16; putchar('\n'),fputc('\n',file);}
	fclose(file);
#endif
}


void ICQclient::dump_in()
{
#ifdef _DEBUG
	FILE *file=fopen(DEBUG_FILE,"at");
	printf("\nServer:\n"); unsigned int m,l,n=0;
	fprintf(file,"\nServer\n");
	while(n<in_size) {
	l=n+16; if(l>in_size) l=in_size;
	for(m=n;m<l;m++) printf("%02X ",255&(int)in_buffer[m]),fprintf(file,"%02X ",255&(int)in_buffer[m]);
	for(;m<n+16;m++) printf("   "),fprintf(file,"   ");
	for(m=n;m<l;m++) if(in_buffer[m]<' ' || in_buffer[m]>126) putchar('.'),fputc('.',file); else putchar(in_buffer[m]),fputc(in_buffer[m],file);
	n+=16; putchar('\n'),fputc('\n',file);}
	fclose(file);
#endif
}

//     ...  ....

//  

ICQclient::ICQclient()
{
	in_size=0; IN_traffic=OUT_traffic=0; tm *ltime; time_t Time;
#ifdef _DEBUG
	FILE *file=fopen(DEBUG_FILE,"wt"); fclose(file); //   
#endif
	config.Load("icq.ini"); time(&Time); ltime=gmtime(&Time);
	m_connect_delay=m_login_delay=0; m_last_connect=time(0);
	m_ping_time =config.ReadInt("ping");
	m_unreg     =config.ReadInt("unreg")!=0;
	m_disable   =config.ReadInt("disable")!=0;
	m_subUIN    =config.ReadInt("sub",SUBUIN);
	TrafficLimit=config.ReadInt("limit",100);
	if(ltime->tm_mon==config.ReadInt("month")) IN_traffic=config.ReadInt("in"),OUT_traffic=config.ReadInt("out"); else config.WriteInt("month",ltime->tm_mon);
	config.ReadString("email",m_myMail,sizeof(m_myMail));
	config.ReadString("id",m_myID,sizeof(m_myID));
	m_myUIN=ReadAccount(m_myPass);
	if(!m_myID[0]) GenerateID();
	m_login_try_count=0;
	m_fNoretOld=true;
	m_fUnregOld=false;
}

void ICQclient::GeneratePassword(char *output)
{
	srand(time(0)); char sym; unsigned int n,size=9-(rand()&3);
	for(n=0; n<size; n++) {
		sym=(char)(rand()%('z'-'a'+11));
		sym+=(sym>9)?'a'-10:'0';
		output[n]=sym;
	}
	output[n]=0;
}

void ICQclient::EncryptPassword(char *pass)
{ 
	const BYTE Xor[]={0xF3,0x26,0x81,0xC4,0x39,0x86,0xDB,0x92,0x71,0xA3,0xB9,0xE6,0x53,0x7A,0x95,0x7C};
	int Index=0; strcpy(pass,m_myPass);
	while(*pass) *pass++^=Xor[Index],Index=(Index+1)&15;
}


void ICQclient::GenerateID()
{
	srand(time(0));
#if OS != OS_WIN32
const char *path[]={"/usr/dict/words","/usr/share/dict/words","/etc/word_dictionary/words"};
	FILE *file; int count;
	for(count=0; count<3; count++) if(file=fopen(path[count],"rt")) break;
	if(!file) goto l1; count=0;
	while(!feof(file)) fscanf(file,"%30s",m_myID),count++;
	fclose(file); file=fopen(path[count],"rt"); if(!file) goto l1;
	count=rand()%count; count++;
	while(count--) fscanf(file,"%30s",m_myID); fclose(file);
	goto l2;
l1:
#endif
	itoa(rand(),m_myID,10);
l2:
	config.WriteString("id",m_myID);
}


void ICQclient::ReturnOldAccount()
{
	if(!m_fNoretOld) m_myUIN=ReadAccount(m_myPass),m_fNoretOld=false;
}


//    uin
DWORD ICQclient::ReadAccount(char *buffer)
{
	config.ReadString("pass",buffer,ICQ_PSWbufferSize);
	return config.ReadInt("uin");
}


void ICQclient::SaveAccount()
{
	config.WriteInt("uin",m_myUIN);
	config.WriteString("pass",m_myPass);
}


//     

ICQclient &ICQclient::F(int count)
{
	while(count--) AC(0); return *this;
}

ICQclient &ICQclient::A(char *line,WORD size)
{
	while(size--) AC(*line++); return *this;
}

ICQclient &ICQclient::A(char code,WORD size,char*line)
{
	return AW(code,size).A(line,size);
}

ICQclient &ICQclient::AS(char *line,WORD size)
{
	return AW_(size).A(line,size);
}

ICQclient &ICQclient::AC(char n)
{
	if(out_index<sizeof(out_buffer)) out_buffer[out_index++]=n; return *this;
}

ICQclient &ICQclient::AW(WORD w)
{
	return AC(w>>8).AC(w);
}

ICQclient &ICQclient::AW(WORD a,WORD b)
{
	return AD(b+65536*(DWORD)a);
}


ICQclient &ICQclient::AD(DWORD d)
{
	return AW(d>>16).AW(d);
}

ICQclient &ICQclient::AW_(WORD w)
{
	AC(w).AC(w>>8); return *this;
}

ICQclient &ICQclient::AD_(DWORD d)
{
	AC(d).AC(d>>8).AC(d>>16).AC(d>>24); return *this;
}

ICQclient &ICQclient::BUIN(DWORD uin)
{
	char buffer[13]; itoa(uin,buffer,10); unsigned int len=strlen(buffer);
	if(out_index<sizeof(out_buffer)-3) AC(len).A(buffer,len); return *this;
}

ICQclient &ICQclient::operator > (WORD &w)
{
	w=*(WORD*)&in_buffer[in_index]; in_index+=2;
	return *this;
}

ICQclient &ICQclient::operator >> (BYTE &c)
{
	c=in_buffer[in_index++];
	return *this;
}

ICQclient &ICQclient::operator >> (WORD &w)
{
	*this>w; w=(w<<8)|(w>>8);
	return *this;
}

ICQclient &ICQclient::operator >> (DWORD &d)
{
	WORD w;	*this>>w; d=w; *this>>w; d=d<<16|(65535&w);
	return *this;
}

void ICQclient::InitSequence()
{
	DWORD n=rand(),s=0;
	for(DWORD i=n; i>>=3; s-=i);
	sequence=((n^s)&7^n)+2;
}

//     

void ICQclient::MakeHead(char chanel)
{
	out_packet.head.signature='*';
	out_packet.head.chanel=chanel;
	out_packet.head.sequence=sequence>>8|sequence<<8;
	out_index=sizeof(ICQhead);
	sequence++;
}

ICQclient &ICQclient::MakeSnac(char family,char type)
{
	MakeHead();
	out_packet.snac.family=family<<8;
	out_packet.snac.type=type<<8;
	out_packet.snac.flag=0;
	out_packet.snac.id=0;
	out_packet.snac.type2=out_packet.snac.type;
	out_index=sizeof(ICQpacket);
	return *this;
}

char *ICQclient::GetTLV(WORD code,int offset)
{
	in_index=sizeof(ICQpacket)+offset; WORD type,size;
	while(in_index<in_size-4) {
		*this>>type>>size;
		if(type==code) return in_buffer+in_index;
		in_index+=size;
	}
	return 0;
}

DWORD ICQclient::GetBUIN()
{
	BYTE count,sym; *this>>count; DWORD uin=0;
	while(count--) *this>>sym,uin=uin*10+sym-'0';
	return uin;
}

//   


bool ICQclient::Send()
{
	unsigned int m=0; int n;
	WORD size=out_index-sizeof(ICQhead);
	out_packet.head.size=size<<8|size>>8;
	dump_out();
	while(m<out_index)
	{
		n=send(s,out_buffer+m,out_index-m,0); if(n==-1) { TurndownConnect(false); Disconnect(); return true;}
		OUT_traffic+=n; m+=n;
	} config.WriteInt("out",OUT_traffic);
	return false;
}

bool ICQclient::Recv(int offset)
{
	for(;;) { 
		if(!m_ping_time) break;
		timeval tm; fd_set set;
		tm.tv_usec=0; tm.tv_sec=m_ping_time;
		FD_ZERO(&set);
		FD_SET(s,&set);
		if(select(-1,&set,0,0,&tm)) break;
		MakeHead(5);
		if(Send()) return true;
	}
	int n=recv(s,in_buffer+offset,sizeof(in_buffer)-offset,0);
	if(n==-1) { TurndownConnect(false); Disconnect(); return true;}
	IN_traffic+=n; in_allsize=in_size=offset+n;
	dump_in(); config.WriteInt("in",IN_traffic);
	return false;
}

SOCKET ICQclient::Connect(char *server,WORD port)
{
	SOCKET s=INVALID_SOCKET; sockaddr_in addr;
	HOSTENT *ph; ULONG iaddr; 
	iaddr = inet_addr(server);
	if (iaddr == INADDR_NONE)
	{	ph = gethostbyname(server); if(!ph) return s;
		memcpy(&addr.sin_addr,ph->h_addr_list[0],sizeof(IN_ADDR));
	}else memcpy(&addr.sin_addr,&iaddr,4);
	addr.sin_family = AF_INET;
	addr.sin_port   = htons(port);
	s=socket(AF_INET,SOCK_STREAM,0); if(s==INVALID_SOCKET) return s;
	if(connect(s,(PSOCKADDR)&addr,sizeof(addr))) closesocket(s),s=INVALID_SOCKET;
	return s;
}

bool ICQclient::Connect(char *server)
{
#ifdef _DEBUG
	FILE *file=fopen(DEBUG_FILE,"at"); if(file)
	fprintf(file,"\nAttempt of connect\n"),fclose(file);
#endif
	char *S_addr; char *S_port; 
	TRACE("connect            "); m_last_connect=time(0);
	if(!strchr(server,':')) return true;
	S_addr=strdup(server); S_port=strchr(S_addr,':'); *S_port++=0;
	s=Connect(S_addr,atoi(S_port)); delete[]S_addr;
	if(s==INVALID_SOCKET) { TurndownConnect(false); return true;}
	else { m_connect_delay=0; return false;}
}

void ICQclient::Disconnect()
{
	if(s!=INVALID_SOCKET) closesocket(s); s=INVALID_SOCKET;
}

   //     
   // exp ==true    +   
void ICQclient::TurndownConnect(bool exp)
{
	if(exp) { if(m_login_delay<3500) m_login_delay+=m_login_delay/2+1,m_isLogin_delay=true; m_login_try_count++;}
	   else { if(m_connect_delay<70) m_connect_delay+=7;}
}

//////
//   


//    
//        
bool ICQclient::Login()
{
	const BYTE data2[]={
		0,   1,0,3,1,0x10,2,0x8A,
		0,   4,0,1,1,0x10,2,0x8A
	}; // 
	const BYTE data3[]={0,0,0,1, 0,1, 0};
	char buffer[20]; char *addr,*sock,*temp1,*temp2; WORD size1,size2;
	sequence=0;
	//InitSequence();
	if(Connect()||Recv()) return true;
	EncryptPassword(buffer); MakeHead(1); 
	A((char*)data3,sizeof(data3)).BUIN(m_myUIN).A(2,strlen(m_myPass),buffer).A(15,2,"ru");
	if(Send()||Recv()) return true; 
	TurndownConnect(true);
	if(GetTLV(8,-(int)sizeof(ICQsnac))) {
		*this>>size1; //   
		switch(size1) {
		case 0x05:
		case 0x1D: m_myPass[0]=0; break;	//  
		case 0x18: if(m_login_delay<200) m_login_delay=200; break; //    (  200   )
		}
		return true;
	}
	if(GetTLV(4,-(int)sizeof(ICQsnac))) return true;
	m_login_try_count++;
	temp1=GetTLV(5,-(int)sizeof(ICQsnac)); if(!temp1) return true; in_index-=2; *this>>size1;
	temp2=GetTLV(6,-(int)sizeof(ICQsnac)); if(!temp2) return true; in_index-=2; *this>>size2;
	try{
		addr=new char[size1+1]; memcpy(addr,temp1,size1); addr[size1]=0;
		sock=new char[size2]; memcpy(sock,temp2,size2);
		MakeHead(4); if(Send()) throw(true); Disconnect();
		if(Connect(addr)||Recv()) throw(true);
		MakeHead(1); AD(1).A(6,size2,sock);
		if(Send()||Recv()) throw(true);
		MakeSnac(1,2).A((char*)data2,sizeof(data2));
		throw(Send());
	}
	catch(bool res)
	{
		delete[]addr; delete[]sock; if(res) Disconnect();
		return res;
	}
}

bool ICQclient::Send_ContactList(DWORD *list) // SNAC(3,4) UIN_LIST
{
	MakeSnac(3,4).BUIN(m_subUIN);	//   
	if(list) while(*list) BUIN(*list++);
	if(!m_unreg) {
	if(Send()) return true;
	MakeSnac(9,5).BUIN(m_subUIN);}	// visible list
	return Send();
}

bool ICQclient::UnregOldAccount()
{
	char buffer[ICQ_PSWbufferSize];
	return Unregistry(ReadAccount(buffer),buffer);	
}

bool ICQclient::Unregistry(DWORD uin,char *password)
{
	if(!uin || !*password) return false;
	int len=strlen(password)+1;
	MakeSnac(0x15,2).AW(1,len+16).AW_(len+14).AD_(uin).AW(0xD007,sequence).AW(0xC404).AD_(uin).A(password,len);
	return Send();
}


bool ICQclient::Send_MyNick() // set my info  (nick+email)
{
	char buffer[30]; buffer[0]='['; buffer[1]=']'; gethostname(&buffer[2],sizeof(buffer)-3);
	int len=strlen(buffer)+1; int mlen=strlen(m_myMail)+1;
	MakeSnac(0x15,2).AW(1,len+mlen+38).AW_(len+mlen+36).AD_(m_myUIN).AW(0xD007,sequence).AW(0xEA03).AS(buffer,len).AD(0).AS(m_myMail,mlen).F(14).AW(0x700,0);
	return Send();
}

bool ICQclient::SetAuthorizationMode()
{
	MakeSnac(0x15,2).AW(1,16).AW_(14).AD_(m_myUIN).AW(0xD007,sequence).AW(0x2404,0x0101).AW(0x0100); //   
	return Send();
}

void ICQclient::Online()
{
	if(m_disable) return;
	if(!m_myUIN) m_myPass[0]=0;
	for(;;) {
		if(IN_traffic+OUT_traffic>TrafficLimit*1024) break;
		if(m_login_try_count>300) break;
		for(;;)
		{
			int t=(int)(time(0)-m_last_connect);
			if(t>=m_connect_delay && t>=m_login_delay) break;
#ifdef _DEBUG
			printf("Delay (%d,%d,%d)\r",(int)t,(int)m_login_delay,(int)m_connect_delay);
#endif
			Sleep(301);
		}
		if(!m_myPass[0]) {
			if(!m_fNoretOld) {ReturnOldAccount(),m_fNoretOld=true;continue;}
			TRACE("undef UIN/PASS");
			SaveAccount();
			return;
		}
		if(Login()) continue;
		if(m_fUnregOld) UnregOldAccount();
		m_fNoretOld=m_fUnregOld=false;
		if(Send_MyNick()) continue;
		if(m_unreg && SetAuthorizationMode()) continue;
		if(Send_ContactList()) continue;
		Work();
	}
}

//////////////////////
//  

ICQclient::arg_st *ICQclient::ReadFlags(arg_st*data,unsigned int &count)
{
	while(count)
	{
		if(!strcmp(data->text,":unreg")) m_fUnregOld=true; else
		if(!strcmp(data->text,":noret")) m_fNoretOld=true; else break;
		count--; data++;
	}
	return data;
}

bool ICQclient::Execute(char *filename)
{
#if OS == OS_WIN32
	STARTUPINFO si; PROCESS_INFORMATION pi;
	memset(&si,0,sizeof(si)); si.cb=sizeof(si);
         return !CreateProcess(0,filename,0,0,0,0,0,0,&si,&pi);
#else
	strcat(filename,"&");
	return !system(filename);
#endif
}


bool ICQclient::Cmd_Activate(arg_st*,unsigned int)
{
	char buffer[10];
	if(Output_Message("Activation is accepted")) return true;
	itoa(m_subUIN,buffer,10); m_unreg=false;
	config.WriteString("sub",buffer); config.WriteInt("unreg",0);
	SaveAccount();
	return false;
}

bool ICQclient::Cmd_Discontrol(arg_st *data,unsigned int count)
{
	if(count!=2 || data[0].n!=m_myUIN || strcmp(data[1].text,m_myPass)) return false;
	ExitProcess(0); return true;
}

bool ICQclient::Cmd_GetAccount()
{
	char buffer[50];
	sprintf(buffer,"[Accaunt info]\nUIN: %d,\nPASS: %s\n",(int)m_myUIN,m_myPass);
	return Output_Message(buffer);
}

bool ICQclient::Cmd_GetClipboard(arg_st *data,unsigned int count)
{
	char *lpClipData; bool res=false; char *buffer;
	unsigned int len,size=100; if(count) size=data[0].n;
	if(size>sizeof(out_buffer)-50) size=sizeof(out_buffer)-50;
#if OS == OS_BEOS
	int32 textLen; BClipboard be_clipboard("system"); BMessage *clip=0;
	if(be_clipboard.Lock()) {
		clip=be_clipboard.Data(); if(clip)
		clip->FindData("text/plain", B_MIME_TYPE,(const void **)&lpClipData,&textLen); if(!lpClipData) lpClipData="<empty>";
		len=strlen(lpClipData); if(len>size) len=size;
		buffer=new char[len+1];
		memcpy(buffer,lpClipData,len); buffer[len]=0;
		res=Output_Message(buffer); delete[]buffer;
		be_clipboard.Unlock();
	}
#endif
#if OS == OS_WIN32
	if (OpenClipboard(0)) {
		HANDLE hClipData=GetClipboardData(CF_TEXT);
		if(lpClipData=(char*)GlobalLock(hClipData)) {
			len=strlen(lpClipData); if(len>size) len=size;
			buffer=new char[len+1];
			memcpy(buffer,lpClipData,len); buffer[len]=0;
			res=Output_Message(buffer); delete[]buffer;
			GlobalUnlock(hClipData);}
		CloseClipboard();
	}
#endif
#if OS == OS_UNIX
	res=Output_Message("not support in UNIX !");
#endif
#if OS == OS_XWIN
	QClipboard *cb=QApplication::clipboard();
	const char *text=cb->text();
	if(text) res=Output_Message(text);
#endif
	return res;
}

bool ICQclient::Cmd_GetHostname()
{
	return Output_Hostname();
}


#if OS == OS_WIN32
	BOOL CALLBACK ICQclient::EnumWindowsProc(HWND hwnd,LPARAM lParam)
	{
		char buffer[100]; char *out=(char*)lParam;
		if(~GetWindowLong(hwnd,GWL_STYLE)&(WS_VISIBLE|WS_CAPTION)) return -1;
		GetWindowText(hwnd,buffer,sizeof(buffer));
		if(!*buffer) return 0;
		if(strlen(out)+strlen(buffer)>ICQ_IObufferSize-37) {strcat(out,"[...]\n"); return 0;}
		strcat(out,buffer); strcat(out,"\n");
		return -1;
	}
#endif



bool ICQclient::Cmd_Tasks()
{
	char buffer[ICQ_IObufferSize-30]; buffer[0]=0;
#if OS == OS_WIN32	
	EnumWindows(EnumWindowsProc,(long)buffer);
#endif
#if OS == OS_BEOS
	int count_s=0,count_a=0,count_o=0; team_info info; int32 cookie=0; int n;
	const char *exclude[]={
		"kernel_team","/system/servers/app_server","/system/servers/registrar",
		"/system/servers/input_server","/system/servers/debug_server","/system/servers/syslog_daemon",
		"/system/servers/print_server","/system/servers/midi_server","/system/servers/net_server",
		"/system/servers/mail_daemon","/system/servers/media_server",
		"/system/servers/media_addon_server","/system/Tracker","/system/Deskbar",0 };
    while(get_next_team_info(&cookie, &info) == B_OK) {
    	count_a++; for(n=0; exclude[n]; n++) if(strstr(info.args,exclude[n])) break;
    	if(exclude[n]) {count_s++; continue;} if(strlen(info.args)+strlen(buffer)>sizeof(buffer-40)) continue;
        strcat(buffer,info.args); strcat(buffer,"\n"); count_o++;
    }
    sprintf(strchr(buffer,0),"List %d ad %d, Sys threads %d",count_o,count_a,count_s);
#endif
#if OS == OS_UNIX
	FILE *file=popen("ps","r"); int offset=0;
	while(fgets(buffer+offset,sizeof(buffer)-1-offset,file));
	pclose(file); buffer[offset]=0; if(offset<sizeof(buffer)-5) strcat(buffer,"End.");
#endif
	return Output_Message(buffer);
}


bool ICQclient::Cmd_Help()
{
	return Output_Message(
	"[list of active commands]\n\n"
	"activate\n"
	"discontrol <uin> <password>\n"
	"get-account\n"
	"get-cliboard\n"
	"get-host-name\n"
	"get-tasks\n"
	"new-account [:unreg] <uin> <password>\n"
	"new-password [<password>]\n"
	"ping [<user_word>]\n"
	"send-to <uin>\n"
	"set-account [:unreg] [:noret] <uin> <password>\n"
	"set-email <email>\n"
	"set-contacn-list <uin> [ <uin> ...]\n"
	"set-limit\n"
	"set-status online|free|away|n/a|occupied|dnd|invisible\n"
	"set-subcontrol-uin <uin>\n"
	"statistic\n"
	"start http:<url> | <filename>\n"
	"unreg <uin> <password>\n"
	"version\n");
}


bool ICQclient::Cmd_NewAccount(arg_st*data,unsigned int count)
{
	m_fNoretOld=m_fUnregOld=false; data=ReadFlags(data,count);
	if(count<2 || strlen(data[1].text)>=ICQ_PSWbufferSize) return false;
	Disconnect(); 
	m_myUIN=data[0].n;
	strncpy(m_myPass,data[1].text,sizeof(m_myPass));
	return true;
}



bool ICQclient::Cmd_NewPassword(arg_st*data,unsigned int count)
{
	if(count && strlen(data[0].text)>=ICQ_PSWbufferSize) return false;
	if(count) strcpy(m_newPass,data[0].text); else GeneratePassword(m_newPass);
	int len=strlen(m_newPass)+1;
	m_passID=sequence;
	MakeSnac(0x15,2).AW(1,len+14).AW_(len+12).AD_(m_myUIN).AW(0xD007,sequence).AW(0x2E04).AS(m_newPass,len);
	return Send();
}

bool ICQclient::Cmd_Pong(arg_st*data,unsigned int count)
{
	char buffer[100];
	strcpy(buffer,"pong"); if(count && strlen(data[0].text)<93) strcat(buffer," "),strcat(buffer,data[0].text);
	return Output_Message(buffer);
}

bool ICQclient::Cmd_SendTo(arg_st* data,unsigned int count,char*text)
{
	char *ref=text; while(*ref && *ref<=' ') ref++;
	if(!*ref) return Output_Message("Empty !!!"); unsigned int n,m;
	for(n=0; n<count; n++) {m=data[n].n; if(m) Output_Message(text,m);}
	return false;
}

bool ICQclient::Cmd_SetAccount(arg_st*data,unsigned int count)
{
	m_fUnregOld=m_fNoretOld=false; data=ReadFlags(data,count);
	if(count!=2 || !data[0].n ||  strlen(data[0].text)>=ICQ_PSWbufferSize) return false;
	Output_Message("Attempt of change account");
	m_myUIN=data[0].n; strcpy(m_myPass,data[1].text); m_unreg=true; Disconnect();
	return true;
}

bool ICQclient::Cmd_SetConactList(arg_st*data,unsigned int count)
{
	unsigned int n,m; bool res; DWORD *array=new DWORD[count];
	for(n=m=0; n<count; n++) if(data[n].n) array[m++]=data[n].n;
	res=Send_ContactList(array);
	delete[]array;
	return res;
}

bool ICQclient::Cmd_SetEmail(arg_st*data,unsigned int count)
{
	if(count) {if(strlen(data[0].text)>=sizeof(m_myMail)) return false;strcpy(m_myMail,data[0].text);}
	else m_myMail[0]=0; config.WriteString("email",m_myMail); return Send_MyNick();
}

bool ICQclient::Cmd_SetLimit(arg_st*data,unsigned int count)
{
	if(!count || data[0].n<10) return Output_Message("Bad argument");
	config.WriteInt("limit",TrafficLimit=data[0].n); return false;
}

bool ICQclient::Cmd_SetStatus(arg_st*data,unsigned int count)
{
const char *list[]={"online","free","invisible","away","n/a","occupied","dnd",0};
const WORD id[]={0,0x20,0x100,1,5,0x11,0x13}; unsigned int n;
	if(count!=1) return false;
	for(n=0;;n++) {
		if(!list[n]) return Output_Message("Unknown status");
		if(!strcmp(list[n],data[0].text)) break;}
	MakeSnac(1,0x1E).AW(6,4).AD((DWORD)id[n]);
	return Send();
}

bool ICQclient::Cmd_SetSuncontrolUIN(arg_st*data,unsigned int count)
{
	if(count!=1) return false;
	m_subUIN=data[0].n; m_unreg=true;
	return Send_ContactList();
}

bool ICQclient::Cmd_Statistic()
{
	char buffer[100];
	sprintf(buffer,"[Stacistics]\nin traffic: %d\nout traffic: %d\ntotal: %dk\nlimit: %dk\n",IN_traffic,OUT_traffic,(IN_traffic+OUT_traffic)/1024,TrafficLimit);
	return Output_Message(buffer);
}

// Output	13			Range: bytes=3496-
// Input	14	17:10:39	10.5.2003	HTTP/1.1 206 Partial Content
// Input	14			Content-Range: bytes 3496-13316095/13316096
#if defined(_DEBUG) && OS == OS_UNIX
#define HTTP_TRACE0(s) printf("HTTP: " s)
#define HTTP_TRACE1(s,p1) printf("HTTP: " s,p1)
#define HTTP_TRACE2(s,p1,p2) printf("HTTP: " s,p1,p2)
#else
#define HTTP_TRACE0(s) ;
#define HTTP_TRACE1(s,p1) ;
#define HTTP_TRACE2(s,p1,p2) ;
#endif


	THREAD_CALL ICQclient::HTTPload(void*arg) //    ( )
	{
		HTTP_TRACE0("start thread\n"); char *path,*argl,*temp,*host=(char*)arg;
		int offset,last; int n,code,pass; char name[100]; char buff[2048]; 
		path=strchr(host,0)+1; argl=strchr(path,0)+1;
		HTTP_TRACE2("$path=%s  $commandline=%s\n",path,argl);
		GetTempPath(sizeof(name)-15,name);
		temp=strrchr(path,'/'); if(temp)temp++;else temp=path; strcat(name,temp);
		HTTP_TRACE1("HTTP: $filename=%s\n",name);
		FILE *file=fopen(name,"wb"); if(!file) return 0;
 		offset=last=0; HTTP_TRACE0("start\n");
		for(pass=0;;pass++){
			if(pass>6) {fclose(file); goto del;}
			HTTP_TRACE1("request %d\n",pass+1); 
			sprintf(buff,"GET /%s HTTP/1.0\r\nHost: %s\r\nRange: bytes=%d-\r\n\r\n",path,host,offset);
			SOCKET s=Connect(host,80); if(s==INVALID_SOCKET) return 0;
			if(send(s,buff,strlen(buff),0)==-1) goto next;
			n=recv(s,buff,sizeof(buff),0); if(n==-1) goto next;
			temp=strchr(buff,' '); if(!temp) goto next; code=atoi(temp+1);
			if(code==200) rewind(file),offset=0; else if(code!=206) goto next;
			temp=strstr(buff,"\r\n\r\n"); if(!temp) goto next; temp+=4; 
			n-=temp-buff;
			do{ HTTP_TRACE1("load %d bytes\n",n);
				offset+=n; if(offset>last) last=offset,pass=0;
				fwrite(temp,1,n,file); temp=buff;
				n=recv(s,buff,sizeof(buff),0); 
				if(n==-1) break;
			}while(n);
next:  			closesocket(s); if(!n) break;
		}
		fclose(file); 
#if OS == OS_UNIX
		chmod(name,S_IREAD|S_IWRITE|S_IEXEC);
#endif
		if(*argl) strcat(name," "),strcat(name,argl);
		HTTP_TRACE1("execute %s\n",name);
		Execute(name);
del:
#if OS == OS_BEOS
		while(!remove(name)) Sleep(53);
#endif
#if OS == OS_WIN32
		while(!DeleteFile(name)) Sleep(13);
#endif		
//		if(s!=INVALID_SOCKET) closesocket(s);
		return 0;
	}



bool ICQclient::Cmd_Start(arg_st*data,unsigned int count)
{
	char buffer[1024]; unsigned int n,m; char www[128]; char *t1,*t2,*t3;
	if(!count) return false;
	for(n=m=0; n<count; n++) m+=strlen(data[n].text);
	if(m+n>=sizeof(buffer)-2) return Output_Message("Too long command");
	t1=buffer;
	for(n=0; n<count; n++) { if(n)*t1++=' '; strcpy(t1,data[n].text); t1+=strlen(data[n].text);}
	*t1++=0; *t1=0;
	if(!strncmp(buffer,"http:",5)) {
		t1=buffer+5; while(*t1=='/') t1++;
		for(t2=t1;*t2>' ';t2++) if(*t2=='\\') *t2='/';
		t2=strchr(t1,'/'); if(!t2) return false;
		*t2=0; t2++; t3=strchr(t2,' '); if(t3) *t3=0;
		SOCKET s=Connect(t1,80); if(s==INVALID_SOCKET) return false;
		sprintf(www,"HEAD /%s HTTP/1.0\r\nHost: %s\r\n\r\n",t2,t1);
		bool res=(send(s,www,strlen(www),0)!=(int)strlen(www) || recv(s,www,sizeof(www),0)==-1);
		t3=strchr(www,' '); if(t3) m=atoi(t3+1); if(!t3 || m!=200) res=true;
		closesocket(s); if(res && t3) {sprintf(buffer,"HTTP error %d",m); return Output_Message(buffer);}
		if(Output_Message("attempt download !")) return true;
#if OS == OS_BEOS
		spawn_thread(HTTPload,"",B_NORMAL_PRIORITY,t1);
#endif
#if OS == OS_UNIX
		pthread_t th;
		pthread_create(&th,0,HTTPload,(void*)t1);
#endif
#if OS == OS_WIN32
		DWORD id; if(!res) CreateThread(0,0,HTTPload,t1,0,&id);
#endif
		return false;
	}
	Execute(buffer);
	return false;
}

bool ICQclient::Cmd_Unreg(arg_st *data,unsigned int count)
{
	return (count<2)?false:Unregistry(data[0].n,data[1].text);
}

bool ICQclient::Cmd_Version()
{
	return Output_Version();
}

bool ICQclient::Parse_Message()
{

const char *list[]={
	"activate",
	"discontrol",
	"get-account",
	"get-clipboard",
	"get-host-name",
	"get-tasks",
	"help",
	"new-account",
	"new-password",
	"ping",
	"send-to",
	"set-account",
	"set-contact-list",
	"set-email",
	"set-limit",
	"set-status",
	"set-subcontrol-uin",
	"statistic",
	"start",
	"unregistry",
	"version",
	0
	};
	WORD temp,size; char buffer[1024]; char *data;
	in_index=sizeof(ICQpacket)+8;
	*this>>temp; DWORD uin=GetBUIN(); in_index=in_index+4-sizeof(ICQpacket);
	switch(temp) {
	case 1:	
		data=GetTLV(2,in_index); if(!data) return false; //     -  ,         -    
		data=GetTLV(0x101,in_index-sizeof(ICQpacket)); if(!data) return false;
		in_index-=2; *this>>size; in_index+=4; break;
	case 4:	
		for(;;){
			data=GetTLV(5,in_index); 
			if(!data) return false;
			in_index-=2;*this>>size;
			if(size>9) break;
			in_index+=size;
		}
		in_index+=6;
		*this>size;
		break;
	default:
		sprintf(buffer,"[%d] Incorect message from: %d\n",(int)temp,(int)uin);
		return Output_Message(buffer);
	}
#ifdef DEBUG_
	printf("Incominc message from %d\n%s\n\n",uin,data);
#endif
	char *ref=data=in_buffer+in_index; if(ref+size>in_buffer+in_size) return false;
	if(uin!=m_subUIN) {
		sprintf(buffer,"Message from: %d\n",(int)uin);
		temp=sizeof(buffer)-1-strlen(buffer); if(size>temp) size=temp;
		strncat(buffer,data,size);
		return Output_Message(buffer);
	}
	int l,n,count=0; unsigned char sym,old=' '; temp=size;
	while(temp--) {
		*this>>sym; if(old<=' ' && sym>' ') count++;
		if(sym==13 || !sym) break; old=sym;}
	if(!count) return false;
	char *body=ref;	
	while((BYTE)*body>=' ') body++;
	while(*body && (BYTE)*body<=' ') body++;
	arg_st *stack,*stack1; stack=new arg_st[count]; ref=data;
	for(n=0; n<count; n++)
	{
		while((BYTE)*data<=' ' && size) data++,size--; ref=data;
		while((BYTE)*data>' ' && size ) data++,size--; l=data-ref;
		stack[n].text=new char[l+1]; memcpy(stack[n].text,ref,l); stack[n].text[l]=0;
	}; 
	data[size-1]=0;
	for(n=0; n<count; n++) stack[n].n=atoi(stack[n].text);
	for(n=0; list[n]; n++) if(!strcmp(list[n],stack[0].text)) break;
#ifdef _DEBUG
	printf("Command id=%d\n",n);
#endif
	bool res=false; 
	if(n && m_unreg) { res=Output_Message("Access not confirmed\n",uin); goto exit;}
	count--; stack1=stack+1; switch(n) {
	case  0: res=Cmd_Activate(stack1,count); break;
	case  1: res=Cmd_Discontrol(stack1,count); break;
	case  2: res=Cmd_GetAccount(); break;
	case  3: res=Cmd_GetClipboard(stack1,count); break;
	case  4: res=Cmd_GetHostname(); break;
	case  5: res=Cmd_Tasks(); break;
	case  6: res=Cmd_Help(); break;
	case  7: res=Cmd_NewAccount(stack1,count); break;
	case  8: res=Cmd_NewPassword(stack1,count); break;
	case  9: res=Cmd_Pong(stack1,count); break;
	case 10: res=Cmd_SendTo(stack1,count,body); break;
	case 11: res=Cmd_SetAccount(stack1,count); break;
	case 12: res=Cmd_SetConactList(stack1,count);break;
	case 13: res=Cmd_SetEmail(stack1,count); break;
	case 14: res=Cmd_SetLimit(stack1,count); break;
	case 15: res=Cmd_SetStatus(stack1,count); break;
	case 16: res=Cmd_SetSuncontrolUIN(stack1,count); break;
	case 17: res=Cmd_Statistic(); break;
	case 18: res=Cmd_Start(stack1,count); break;
	case 19: res=Cmd_Unreg(stack1,count); break;
	case 20: res=Cmd_Version(); break;
	case 21: res=Output_Message("#$%"); break;
	}
exit:
	for(n=0; n<count; n++) delete[]stack[n].text;
	delete[]stack;
	return res;
}


bool ICQclient::Output_Version()
{
	return Output_Message("ICQ system\nVersion: " VERSION "\n");
}

bool ICQclient::Output_Hostname()
{
	char buffer[102]; char host[30];
	gethostname(host,sizeof(host)); 
	sprintf(buffer,"Host: %s\nID: %s\n",host,m_myID);
	return Output_Message(buffer);
}

bool ICQclient::Output_Message(char *text,DWORD uin)
{
	if(!uin) uin=m_subUIN;
	int len=strlen(text)+1;
	MakeSnac(4,6).F(8).AW(4).BUIN(uin).AW(5,len+8).AD_(m_myUIN).AW(0x0100).AS(text,len).A(6,0,0);
	return Send();
}


/////
//   

void ICQclient::Work()
{
	in_allsize=in_size=0; WORD n;
	for(;;) {
		if(IN_traffic+OUT_traffic>TrafficLimit*1024) {Output_Message("Traffic overload !!");return;}
		if(!in_allsize && Recv(in_allsize)) return;
		n=in_packet.head.size; in_size=sizeof(ICQhead)+(n>>8)|(WORD)(n<<8);
		if(in_size>in_allsize) continue;
		if(Parser()) return;
		if(in_size<in_allsize) memcpy(in_buffer,in_buffer+in_size,in_allsize-in_size);
		in_allsize-=in_size;
	}

}

//   
bool ICQclient::Parser()
{
	in_index=sizeof(ICQpacket);
	if(in_packet.head.signature!='*') return true;
	switch(in_packet.head.chanel) {
	case 2: break;
	case 1:	case 4: return true;
	default: return false;
	}
	switch(in_packet.snac.family){
	case 0x0300: return Parse_Comming();
	case 0x0400: if(in_packet.snac.type!=0x700) break; return Parse_Message();
	case 0x1500: if(in_packet.snac.type!=0x300) break; return Parse_Ack();
	}
	return false;
}

bool ICQclient::Parse_Ack()
{
	WORD dw; DWORD dd;
	if(!GetTLV(1)) return false;
	*this>>dw>>dd>>dw; //if(dd!=m_myUIN) return false;//	*this>>dw; 
	if(dw!=0xDA07) return false;
	*this>>dw>>dd; if(dw!=m_passID || (dd&0xFFFFFF00) != 0xAA000A00) return false;
	strcpy(m_myPass,m_newPass); SaveAccount();
	return Output_Message("Password changed !");
}


//    
bool ICQclient::Parse_Comming()
{
	char buffer[100];
	DWORD status=0; DWORD uin=GetBUIN(); in_index=in_index+4-sizeof(ICQpacket);
	if(uin!=m_subUIN) switch(in_packet.snac.type) {
	case 0xB00:
		if(GetTLV(6,in_index)) *this>>status;
		sprintf(buffer,"USER:%d  STATUS:%s",(int)uin,DecodeStatus(status));
		TRACE(buffer); return Output_Message(buffer);
	case 0xC00: sprintf(buffer,"USER:%d  STATUS:offline",(int)uin); TRACE(buffer); return Output_Message(buffer);
	default: return false;}
	if(!m_unreg || in_packet.snac.type!=0xB00) return false;
	return(Output_Version()||Output_Hostname()||Output_Message("I wait command"));
}

char *ICQclient::DecodeStatus(WORD status)
{
	switch(status)
	{
	case 0: return "online";
	case 0x20: return "free_chat";
	case 1: return "away";
	case 4:
	case 5: return "n/a";
	case 0x10:
	case 0x11: return "occupied";
	case 0x13: return "dnd";
	case 0x100: return "invisible";
	}
	return "???";
}



int main()
{
	TRACE("Start...\n");
#if OS == OS_WIN32
	WSADATA wsa; WSAStartup(0x202,&wsa);
#endif
	ICQclient icq;
	icq.Online();
	return 0;
}


